Index: branches/HTM-14.1-update-dev0/source/Lib/TLibDecoder/TDecSlice.cpp
===================================================================
--- branches/HTM-14.1-update-dev0/source/Lib/TLibDecoder/TDecSlice.cpp	(revision 1199)
+++ branches/HTM-14.1-update-dev0/source/Lib/TLibDecoder/TDecSlice.cpp	(revision 1200)
@@ -2,7 +2,7 @@
  * License, included below. This software may be subject to other third party
  * and contributor rights, including patent rights, and no such rights are
- * granted under this license.  
- *
-* Copyright (c) 2010-2015, ITU/ISO/IEC
+ * granted under this license.
+ *
+ * Copyright (c) 2010-2015, ITU/ISO/IEC
  * All rights reserved.
  *
@@ -47,27 +47,8 @@
 TDecSlice::TDecSlice()
 {
-  m_pcBufferSbacDecoders = NULL;
-  m_pcBufferBinCABACs    = NULL;
-  m_pcBufferLowLatSbacDecoders = NULL;
-  m_pcBufferLowLatBinCABACs    = NULL;
 }
 
 TDecSlice::~TDecSlice()
 {
-  for (std::vector<TDecSbac*>::iterator i = CTXMem.begin(); i != CTXMem.end(); i++)
-  {
-    delete (*i);
-  }
-  CTXMem.clear();
-}
-
-Void TDecSlice::initCtxMem(  UInt i )                
-{   
-  for (std::vector<TDecSbac*>::iterator j = CTXMem.begin(); j != CTXMem.end(); j++)
-  {
-    delete (*j);
-  }
-  CTXMem.clear(); 
-  CTXMem.resize(i); 
 }
 
@@ -78,24 +59,4 @@
 Void TDecSlice::destroy()
 {
-  if ( m_pcBufferSbacDecoders )
-  {
-    delete[] m_pcBufferSbacDecoders;
-    m_pcBufferSbacDecoders = NULL;
-  }
-  if ( m_pcBufferBinCABACs )
-  {
-    delete[] m_pcBufferBinCABACs;
-    m_pcBufferBinCABACs = NULL;
-  }
-  if ( m_pcBufferLowLatSbacDecoders )
-  {
-    delete[] m_pcBufferLowLatSbacDecoders;
-    m_pcBufferLowLatSbacDecoders = NULL;
-  }
-  if ( m_pcBufferLowLatBinCABACs )
-  {
-    delete[] m_pcBufferLowLatBinCABACs;
-    m_pcBufferLowLatBinCABACs = NULL;
-  }
 }
 
@@ -106,15 +67,24 @@
 }
 
-Void TDecSlice::decompressSlice(TComInputBitstream** ppcSubstreams, TComPic*& rpcPic, TDecSbac* pcSbacDecoder, TDecSbac* pcSbacDecoders)
-{
-  TComDataCU* pcCU;
-  UInt        uiIsLast = 0;
-  Int   iStartCUEncOrder = max(rpcPic->getSlice(rpcPic->getCurrSliceIdx())->getSliceCurStartCUAddr()/rpcPic->getNumPartInCU(), rpcPic->getSlice(rpcPic->getCurrSliceIdx())->getSliceSegmentCurStartCUAddr()/rpcPic->getNumPartInCU());
-  Int   iStartCUAddr = rpcPic->getPicSym()->getCUOrderMap(iStartCUEncOrder);
-
-  // decoder don't need prediction & residual frame buffer
-  rpcPic->setPicYuvPred( 0 );
-  rpcPic->setPicYuvResi( 0 );
-  
+Void TDecSlice::decompressSlice(TComInputBitstream** ppcSubstreams, TComPic* pcPic, TDecSbac* pcSbacDecoder)
+{
+  TComSlice* pcSlice                 = pcPic->getSlice(pcPic->getCurrSliceIdx());
+
+  const Int  startCtuTsAddr          = pcSlice->getSliceSegmentCurStartCtuTsAddr();
+  const Int  startCtuRsAddr          = pcPic->getPicSym()->getCtuTsToRsAddrMap(startCtuTsAddr);
+  const UInt numCtusInFrame          = pcPic->getNumberOfCtusInFrame();
+
+  const UInt frameWidthInCtus        = pcPic->getPicSym()->getFrameWidthInCtus();
+  const Bool depSliceSegmentsEnabled = pcSlice->getPPS()->getDependentSliceSegmentsEnabledFlag();
+  const Bool wavefrontsEnabled       = pcSlice->getPPS()->getEntropyCodingSyncEnabledFlag();
+
+  m_pcEntropyDecoder->setEntropyDecoder ( pcSbacDecoder  );
+  m_pcEntropyDecoder->setBitstream      ( ppcSubstreams[0] );
+  m_pcEntropyDecoder->resetEntropy      (pcSlice);
+
+  // decoder doesn't need prediction & residual frame buffer
+  pcPic->setPicYuvPred( 0 );
+  pcPic->setPicYuvResi( 0 );
+
 #if ENC_DEC_TRACE
   g_bJustDoIt = g_bEncDecTraceEnable;
@@ -122,8 +92,8 @@
   DTRACE_CABAC_VL( g_nSymbolCounter++ );
   DTRACE_CABAC_T( "\tPOC: " );
-  DTRACE_CABAC_V( rpcPic->getPOC() );
+  DTRACE_CABAC_V( pcPic->getPOC() );
 #if H_MV_ENC_DEC_TRAC
   DTRACE_CABAC_T( " Layer: " );
-  DTRACE_CABAC_V( rpcPic->getLayerId() );
+  DTRACE_CABAC_V( pcPic->getLayerId() );
 #endif
   DTRACE_CABAC_T( "\n" );
@@ -133,90 +103,22 @@
 #endif
 
-  UInt uiTilesAcross   = rpcPic->getPicSym()->getNumColumnsMinus1()+1;
-  TComSlice*  pcSlice = rpcPic->getSlice(rpcPic->getCurrSliceIdx());
-  Int  iNumSubstreams = pcSlice->getPPS()->getNumSubstreams();
-
-  // delete decoders if already allocated in previous slice
-  if (m_pcBufferSbacDecoders)
-  {
-    delete [] m_pcBufferSbacDecoders;
-  }
-  if (m_pcBufferBinCABACs) 
-  {
-    delete [] m_pcBufferBinCABACs;
-  }
-  // allocate new decoders based on tile numbaer
-  m_pcBufferSbacDecoders = new TDecSbac    [uiTilesAcross];  
-  m_pcBufferBinCABACs    = new TDecBinCABAC[uiTilesAcross];
-  for (UInt ui = 0; ui < uiTilesAcross; ui++)
-  {
-    m_pcBufferSbacDecoders[ui].init(&m_pcBufferBinCABACs[ui]);
-  }
-  //save init. state
-  for (UInt ui = 0; ui < uiTilesAcross; ui++)
-  {
-    m_pcBufferSbacDecoders[ui].load(pcSbacDecoder);
-  }
-
-  // free memory if already allocated in previous call
-  if (m_pcBufferLowLatSbacDecoders)
-  {
-    delete [] m_pcBufferLowLatSbacDecoders;
-  }
-  if (m_pcBufferLowLatBinCABACs)
-  {
-    delete [] m_pcBufferLowLatBinCABACs;
-  }
-  m_pcBufferLowLatSbacDecoders = new TDecSbac    [uiTilesAcross];  
-  m_pcBufferLowLatBinCABACs    = new TDecBinCABAC[uiTilesAcross];
-  for (UInt ui = 0; ui < uiTilesAcross; ui++)
-  {
-    m_pcBufferLowLatSbacDecoders[ui].init(&m_pcBufferLowLatBinCABACs[ui]);
-  }
-  //save init. state
-  for (UInt ui = 0; ui < uiTilesAcross; ui++)
-  {
-    m_pcBufferLowLatSbacDecoders[ui].load(pcSbacDecoder);
-  }
-
-  UInt uiWidthInLCUs  = rpcPic->getPicSym()->getFrameWidthInCU();
-  //UInt uiHeightInLCUs = rpcPic->getPicSym()->getFrameHeightInCU();
-  UInt uiCol=0, uiLin=0, uiSubStrm=0;
-
-  UInt uiTileCol;
-  UInt uiTileStartLCU;
-  UInt uiTileLCUX;
-  Int iNumSubstreamsPerTile = 1; // if independent.
-  Bool depSliceSegmentsEnabled = rpcPic->getSlice(rpcPic->getCurrSliceIdx())->getPPS()->getDependentSliceSegmentsEnabledFlag();
-  uiTileStartLCU = rpcPic->getPicSym()->getTComTile(rpcPic->getPicSym()->getTileIdxMap(iStartCUAddr))->getFirstCUAddr();
-  if( depSliceSegmentsEnabled )
-  {
-    if( (!rpcPic->getSlice(rpcPic->getCurrSliceIdx())->isNextSlice()) &&
-       iStartCUAddr != rpcPic->getPicSym()->getTComTile(rpcPic->getPicSym()->getTileIdxMap(iStartCUAddr))->getFirstCUAddr())
-    {
-      if(pcSlice->getPPS()->getEntropyCodingSyncEnabledFlag())
-      {
-        uiTileCol = rpcPic->getPicSym()->getTileIdxMap(iStartCUAddr) % (rpcPic->getPicSym()->getNumColumnsMinus1()+1);
-        m_pcBufferSbacDecoders[uiTileCol].loadContexts( CTXMem[1]  );//2.LCU
-        if ( (iStartCUAddr%uiWidthInLCUs+1) >= uiWidthInLCUs  )
-        {
-          uiTileLCUX = uiTileStartLCU % uiWidthInLCUs;
-          uiCol     = iStartCUAddr % uiWidthInLCUs;
-          if(uiCol==uiTileLCUX)
-          {
-            CTXMem[0]->loadContexts(pcSbacDecoder);
-          }
-        }
-      }
-      pcSbacDecoder->loadContexts(CTXMem[0] ); //end of depSlice-1
-      pcSbacDecoders[uiSubStrm].loadContexts(pcSbacDecoder);
-    }
-    else
-    {
-      if(pcSlice->getPPS()->getEntropyCodingSyncEnabledFlag())
-      {
-        CTXMem[1]->loadContexts(pcSbacDecoder);
-      }
-      CTXMem[0]->loadContexts(pcSbacDecoder);
+  // The first CTU of the slice is the first coded substream, but the global substream number, as calculated by getSubstreamForCtuAddr may be higher.
+  // This calculates the common offset for all substreams in this slice.
+  const UInt subStreamOffset=pcPic->getSubstreamForCtuAddr(startCtuRsAddr, true, pcSlice);
+
+
+  if (depSliceSegmentsEnabled)
+  {
+    // modify initial contexts with previous slice segment if this is a dependent slice.
+    const UInt startTileIdx=pcPic->getPicSym()->getTileIdxMap(startCtuRsAddr);
+    const TComTile *pCurrentTile=pcPic->getPicSym()->getTComTile(startTileIdx);
+    const UInt firstCtuRsAddrOfTile = pCurrentTile->getFirstCtuRsAddr();
+
+    if( pcSlice->getDependentSliceSegmentFlag() && startCtuRsAddr != firstCtuRsAddrOfTile)
+    {
+      if ( pCurrentTile->getTileWidthInCtus() >= 2 || !wavefrontsEnabled)
+      {
+        pcSbacDecoder->loadContexts(&m_lastSliceSegmentEndContextState);
+      }
     }
   }
@@ -227,91 +129,48 @@
   }
 #endif
-  for( Int iCUAddr = iStartCUAddr; !uiIsLast && iCUAddr < rpcPic->getNumCUsInFrame(); iCUAddr = rpcPic->getPicSym()->xCalculateNxtCUAddr(iCUAddr) )
-  {
-    pcCU = rpcPic->getCU( iCUAddr );
-    pcCU->initCU( rpcPic, iCUAddr );
-    uiTileCol = rpcPic->getPicSym()->getTileIdxMap(iCUAddr) % (rpcPic->getPicSym()->getNumColumnsMinus1()+1); // what column of tiles are we in?
-    uiTileStartLCU = rpcPic->getPicSym()->getTComTile(rpcPic->getPicSym()->getTileIdxMap(iCUAddr))->getFirstCUAddr();
-    uiTileLCUX = uiTileStartLCU % uiWidthInLCUs;
-    uiCol     = iCUAddr % uiWidthInLCUs;
-    // The 'line' is now relative to the 1st line in the slice, not the 1st line in the picture.
-    uiLin     = (iCUAddr/uiWidthInLCUs)-(iStartCUAddr/uiWidthInLCUs);
-    // inherit from TR if necessary, select substream to use.
-    if( (pcSlice->getPPS()->getNumSubstreams() > 1) || ( depSliceSegmentsEnabled  && (uiCol == uiTileLCUX)&&(pcSlice->getPPS()->getEntropyCodingSyncEnabledFlag()) ))
-    {
-      // independent tiles => substreams are "per tile".  iNumSubstreams has already been multiplied.
-      iNumSubstreamsPerTile = iNumSubstreams/rpcPic->getPicSym()->getNumTiles();
-      uiSubStrm = rpcPic->getPicSym()->getTileIdxMap(iCUAddr)*iNumSubstreamsPerTile
-                  + uiLin%iNumSubstreamsPerTile;
-      m_pcEntropyDecoder->setBitstream( ppcSubstreams[uiSubStrm] );
-      // Synchronize cabac probabilities with upper-right LCU if it's available and we're at the start of a line.
-      if (((pcSlice->getPPS()->getNumSubstreams() > 1) || depSliceSegmentsEnabled ) && (uiCol == uiTileLCUX)&&(pcSlice->getPPS()->getEntropyCodingSyncEnabledFlag()))
-      {
-        // We'll sync if the TR is available.
-        TComDataCU *pcCUUp = pcCU->getCUAbove();
-        UInt uiWidthInCU = rpcPic->getFrameWidthInCU();
-        TComDataCU *pcCUTR = NULL;
-        if ( pcCUUp && ((iCUAddr%uiWidthInCU+1) < uiWidthInCU)  )
-        {
-          pcCUTR = rpcPic->getCU( iCUAddr - uiWidthInCU + 1 );
-        }
-        UInt uiMaxParts = 1<<(pcSlice->getSPS()->getMaxCUDepth()<<1);
-
-        if ( (true/*bEnforceSliceRestriction*/ &&
-             ((pcCUTR==NULL) || (pcCUTR->getSlice()==NULL) || 
-             ((pcCUTR->getSCUAddr()+uiMaxParts-1) < pcSlice->getSliceCurStartCUAddr()) ||
-             ((rpcPic->getPicSym()->getTileIdxMap( pcCUTR->getAddr() ) != rpcPic->getPicSym()->getTileIdxMap(iCUAddr)))
-             ))
-           )
-        {
-          // TR not available.
-        }
-        else
-        {
-          // TR is available, we use it.
-          pcSbacDecoders[uiSubStrm].loadContexts( &m_pcBufferSbacDecoders[uiTileCol] );
-        }
-      }
-      pcSbacDecoder->load(&pcSbacDecoders[uiSubStrm]);  //this load is used to simplify the code (avoid to change all the call to pcSbacDecoders)
-    }
-    else if ( pcSlice->getPPS()->getNumSubstreams() <= 1 )
-    {
-      // Set variables to appropriate values to avoid later code change.
-      iNumSubstreamsPerTile = 1;
-    }
-
-    if ( (iCUAddr == rpcPic->getPicSym()->getTComTile(rpcPic->getPicSym()->getTileIdxMap(iCUAddr))->getFirstCUAddr()) && // 1st in tile.
-         (iCUAddr!=0) && (iCUAddr!=rpcPic->getPicSym()->getPicSCUAddr(rpcPic->getSlice(rpcPic->getCurrSliceIdx())->getSliceCurStartCUAddr())/rpcPic->getNumPartInCU())
-         && (iCUAddr!=rpcPic->getPicSym()->getPicSCUAddr(rpcPic->getSlice(rpcPic->getCurrSliceIdx())->getSliceSegmentCurStartCUAddr())/rpcPic->getNumPartInCU())
-         ) // !1st in frame && !1st in slice
-    {
-      if (pcSlice->getPPS()->getNumSubstreams() > 1)
-      {
-        // We're crossing into another tile, tiles are independent.
-        // When tiles are independent, we have "substreams per tile".  Each substream has already been terminated, and we no longer
-        // have to perform it here.
-        // For TILES_DECODER, there can be a header at the start of the 1st substream in a tile.  These are read when the substreams
-        // are extracted, not here.
-      }
-      else
-      {
-        SliceType sliceType  = pcSlice->getSliceType();
-        if (pcSlice->getCabacInitFlag())
-        {
-          switch (sliceType)
-          {
-          case P_SLICE:           // change initialization table to B_SLICE intialization
-            sliceType = B_SLICE; 
-            break;
-          case B_SLICE:           // change initialization table to P_SLICE intialization
-            sliceType = P_SLICE; 
-            break;
-          default     :           // should not occur
-            assert(0);
-          }
-        }
-        m_pcEntropyDecoder->updateContextTables( sliceType, pcSlice->getSliceQp() );
-      }
-      
+
+  // for every CTU in the slice segment...
+
+  Bool isLastCtuOfSliceSegment = false;
+  for( UInt ctuTsAddr = startCtuTsAddr; !isLastCtuOfSliceSegment && ctuTsAddr < numCtusInFrame; ctuTsAddr++)
+  {
+    const UInt ctuRsAddr = pcPic->getPicSym()->getCtuTsToRsAddrMap(ctuTsAddr);
+    const TComTile &currentTile = *(pcPic->getPicSym()->getTComTile(pcPic->getPicSym()->getTileIdxMap(ctuRsAddr)));
+    const UInt firstCtuRsAddrOfTile = currentTile.getFirstCtuRsAddr();
+    const UInt tileXPosInCtus = firstCtuRsAddrOfTile % frameWidthInCtus;
+    const UInt tileYPosInCtus = firstCtuRsAddrOfTile / frameWidthInCtus;
+    const UInt ctuXPosInCtus  = ctuRsAddr % frameWidthInCtus;
+    const UInt ctuYPosInCtus  = ctuRsAddr / frameWidthInCtus;
+    const UInt uiSubStrm=pcPic->getSubstreamForCtuAddr(ctuRsAddr, true, pcSlice)-subStreamOffset;
+    TComDataCU* pCtu = pcPic->getCtu( ctuRsAddr );
+    pCtu->initCtu( pcPic, ctuRsAddr );
+
+    m_pcEntropyDecoder->setBitstream( ppcSubstreams[uiSubStrm] );
+
+    // set up CABAC contexts' state for this CTU
+    if (ctuRsAddr == firstCtuRsAddrOfTile)
+    {
+      if (ctuTsAddr != startCtuTsAddr) // if it is the first CTU, then the entropy coder has already been reset
+      {
+        m_pcEntropyDecoder->resetEntropy(pcSlice);
+      }
+    }
+    else if (ctuXPosInCtus == tileXPosInCtus && wavefrontsEnabled)
+    {
+      // Synchronize cabac probabilities with upper-right CTU if it's available and at the start of a line.
+      if (ctuTsAddr != startCtuTsAddr) // if it is the first CTU, then the entropy coder has already been reset
+      {
+        m_pcEntropyDecoder->resetEntropy(pcSlice);
+      }
+      TComDataCU *pCtuUp = pCtu->getCtuAbove();
+      if ( pCtuUp && ((ctuRsAddr%frameWidthInCtus+1) < frameWidthInCtus)  )
+      {
+        TComDataCU *pCtuTR = pcPic->getCtu( ctuRsAddr - frameWidthInCtus + 1 );
+        if ( pCtu->CUIsFromSameSliceAndTile(pCtuTR) )
+        {
+          // Top-right is available, so use it.
+          pcSbacDecoder->loadContexts( &m_entropyCodingSyncContextState );
+        }
+      }
     }
 
@@ -321,126 +180,88 @@
 
     if ( pcSlice->getSPS()->getUseSAO() )
-      {
-      SAOBlkParam& saoblkParam = (rpcPic->getPicSym()->getSAOBlkParam())[iCUAddr];
-      if (pcSlice->getSaoEnabledFlag()||pcSlice->getSaoEnabledFlagChroma())
-      {
-        Bool sliceEnabled[NUM_SAO_COMPONENTS];
-        sliceEnabled[SAO_Y] = pcSlice->getSaoEnabledFlag();
-        sliceEnabled[SAO_Cb]= sliceEnabled[SAO_Cr]= pcSlice->getSaoEnabledFlagChroma();
-
+    {
+      SAOBlkParam& saoblkParam = (pcPic->getPicSym()->getSAOBlkParam())[ctuRsAddr];
+      Bool bIsSAOSliceEnabled = false;
+      Bool sliceEnabled[MAX_NUM_COMPONENT];
+      for(Int comp=0; comp < MAX_NUM_COMPONENT; comp++)
+      {
+        ComponentID compId=ComponentID(comp);
+        sliceEnabled[compId] = pcSlice->getSaoEnabledFlag(toChannelType(compId)) && (comp < pcPic->getNumberValidComponents());
+        if (sliceEnabled[compId])
+        {
+          bIsSAOSliceEnabled=true;
+        }
+        saoblkParam[compId].modeIdc = SAO_MODE_OFF;
+      }
+      if (bIsSAOSliceEnabled)
+      {
         Bool leftMergeAvail = false;
         Bool aboveMergeAvail= false;
 
         //merge left condition
-        Int rx = (iCUAddr % uiWidthInLCUs);
+        Int rx = (ctuRsAddr % frameWidthInCtus);
         if(rx > 0)
         {
-          leftMergeAvail = rpcPic->getSAOMergeAvailability(iCUAddr, iCUAddr-1);
+          leftMergeAvail = pcPic->getSAOMergeAvailability(ctuRsAddr, ctuRsAddr-1);
         }
         //merge up condition
-        Int ry = (iCUAddr / uiWidthInLCUs);
+        Int ry = (ctuRsAddr / frameWidthInCtus);
         if(ry > 0)
         {
-          aboveMergeAvail = rpcPic->getSAOMergeAvailability(iCUAddr, iCUAddr-uiWidthInLCUs);
-      }
-
-        pcSbacDecoder->parseSAOBlkParam( saoblkParam, sliceEnabled, leftMergeAvail, aboveMergeAvail);
-    }
-      else 
-        {
-        saoblkParam[SAO_Y ].modeIdc = SAO_MODE_OFF;
-        saoblkParam[SAO_Cb].modeIdc = SAO_MODE_OFF;
-        saoblkParam[SAO_Cr].modeIdc = SAO_MODE_OFF;
-      }
-    }
-    m_pcCuDecoder->decodeCU     ( pcCU, uiIsLast );
-    m_pcCuDecoder->decompressCU ( pcCU );
-    
+          aboveMergeAvail = pcPic->getSAOMergeAvailability(ctuRsAddr, ctuRsAddr-frameWidthInCtus);
+        }
+
+        pcSbacDecoder->parseSAOBlkParam( saoblkParam, sliceEnabled, leftMergeAvail, aboveMergeAvail, pcSlice->getSPS()->getBitDepths());
+      }
+    }
+
+    m_pcCuDecoder->decodeCtu     ( pCtu, isLastCtuOfSliceSegment );
+    m_pcCuDecoder->decompressCtu ( pCtu );
+
 #if ENC_DEC_TRACE
     g_bJustDoIt = g_bEncDecTraceDisable;
 #endif
-    pcSbacDecoders[uiSubStrm].load(pcSbacDecoder);
-
-    if ( uiCol == rpcPic->getPicSym()->getTComTile(rpcPic->getPicSym()->getTileIdxMap(iCUAddr))->getRightEdgePosInCU()
-        && pcSlice->getPPS()->getEntropyCodingSyncEnabledFlag()
-        && !uiIsLast )
-    {
-      // Parse end_of_substream_one_bit for WPP case
+
+    //Store probabilities of second CTU in line into buffer
+    if ( ctuXPosInCtus == tileXPosInCtus+1 && wavefrontsEnabled)
+    {
+      m_entropyCodingSyncContextState.loadContexts( pcSbacDecoder );
+    }
+
+    if (isLastCtuOfSliceSegment)
+    {
+#if DECODER_CHECK_SUBSTREAM_AND_SLICE_TRAILING_BYTES
+      pcSbacDecoder->parseRemainingBytes(false);
+#endif
+      if(!pcSlice->getDependentSliceSegmentFlag())
+      {
+        pcSlice->setSliceCurEndCtuTsAddr( ctuTsAddr+1 );
+      }
+      pcSlice->setSliceSegmentCurEndCtuTsAddr( ctuTsAddr+1 );
+    }
+    else if (  ctuXPosInCtus + 1 == tileXPosInCtus + currentTile.getTileWidthInCtus() &&
+             ( ctuYPosInCtus + 1 == tileYPosInCtus + currentTile.getTileHeightInCtus() || wavefrontsEnabled)
+            )
+    {
+      // The sub-stream/stream should be terminated after this CTU.
+      // (end of slice-segment, end of tile, end of wavefront-CTU-row)
       UInt binVal;
       pcSbacDecoder->parseTerminatingBit( binVal );
       assert( binVal );
-    }
-
-    //Store probabilities of second LCU in line into buffer
-    if ( (uiCol == uiTileLCUX+1)&& (depSliceSegmentsEnabled || (pcSlice->getPPS()->getNumSubstreams() > 1)) && (pcSlice->getPPS()->getEntropyCodingSyncEnabledFlag()) )
-    {
-      m_pcBufferSbacDecoders[uiTileCol].loadContexts( &pcSbacDecoders[uiSubStrm] );
-    }
-    if( uiIsLast && depSliceSegmentsEnabled )
-    {
-      if (pcSlice->getPPS()->getEntropyCodingSyncEnabledFlag())
-       {
-         CTXMem[1]->loadContexts( &m_pcBufferSbacDecoders[uiTileCol] );//ctx 2.LCU
-       }
-      CTXMem[0]->loadContexts( pcSbacDecoder );//ctx end of dep.slice
-      return;
-    }
-  }
-}
-
-ParameterSetManagerDecoder::ParameterSetManagerDecoder()
-: m_vpsBuffer(MAX_NUM_VPS)
-, m_spsBuffer(MAX_NUM_SPS)
-, m_ppsBuffer(MAX_NUM_PPS)
-{
-}
-
-ParameterSetManagerDecoder::~ParameterSetManagerDecoder()
-{
-
-}
-
-TComVPS* ParameterSetManagerDecoder::getPrefetchedVPS  (Int vpsId)
-{
-  if (m_vpsBuffer.getPS(vpsId) != NULL )
-  {
-    return m_vpsBuffer.getPS(vpsId);
-  }
-  else
-  {
-    return getVPS(vpsId);
-  }
-}
-
-
-TComSPS* ParameterSetManagerDecoder::getPrefetchedSPS  (Int spsId)
-{
-  if (m_spsBuffer.getPS(spsId) != NULL )
-  {
-    return m_spsBuffer.getPS(spsId);
-  }
-  else
-  {
-    return getSPS(spsId);
-  }
-}
-
-TComPPS* ParameterSetManagerDecoder::getPrefetchedPPS  (Int ppsId)
-{
-  if (m_ppsBuffer.getPS(ppsId) != NULL )
-  {
-    return m_ppsBuffer.getPS(ppsId);
-  }
-  else
-  {
-    return getPPS(ppsId);
-  }
-}
-
-Void     ParameterSetManagerDecoder::applyPrefetchedPS()
-{
-  m_vpsMap.mergePSList(m_vpsBuffer);
-  m_ppsMap.mergePSList(m_ppsBuffer);
-  m_spsMap.mergePSList(m_spsBuffer);
+#if DECODER_CHECK_SUBSTREAM_AND_SLICE_TRAILING_BYTES
+      pcSbacDecoder->parseRemainingBytes(true);
+#endif
+    }
+
+  }
+
+  assert(isLastCtuOfSliceSegment == true);
+
+
+  if( depSliceSegmentsEnabled )
+  {
+    m_lastSliceSegmentEndContextState.loadContexts( pcSbacDecoder );//ctx end of dep.slice
+  }
+
 }
 
Index: branches/HTM-14.1-update-dev0/source/Lib/TLibDecoder/TDecSlice.h
===================================================================
--- branches/HTM-14.1-update-dev0/source/Lib/TLibDecoder/TDecSlice.h	(revision 1199)
+++ branches/HTM-14.1-update-dev0/source/Lib/TLibDecoder/TDecSlice.h	(revision 1200)
@@ -2,7 +2,7 @@
  * License, included below. This software may be subject to other third party
  * and contributor rights, including patent rights, and no such rights are
- * granted under this license.  
+ * granted under this license.
  *
-* Copyright (c) 2010-2015, ITU/ISO/IEC
+ * Copyright (c) 2010-2015, ITU/ISO/IEC
  * All rights reserved.
  *
@@ -66,44 +66,17 @@
   TDecCu*         m_pcCuDecoder;
 
-  TDecSbac*       m_pcBufferSbacDecoders;   ///< line to store temporary contexts, one per column of tiles.
-  TDecBinCABAC*   m_pcBufferBinCABACs;
-  TDecSbac*       m_pcBufferLowLatSbacDecoders;   ///< dependent tiles: line to store temporary contexts, one per column of tiles.
-  TDecBinCABAC*   m_pcBufferLowLatBinCABACs;
-  std::vector<TDecSbac*> CTXMem;
-  
+  TDecSbac        m_lastSliceSegmentEndContextState;    ///< context storage for state at the end of the previous slice-segment (used for dependent slices only).
+  TDecSbac        m_entropyCodingSyncContextState;      ///< context storate for state of contexts at the wavefront/WPP/entropy-coding-sync second CTU of tile-row
+
 public:
   TDecSlice();
   virtual ~TDecSlice();
-  
+
   Void  init              ( TDecEntropy* pcEntropyDecoder, TDecCu* pcMbDecoder );
   Void  create            ();
   Void  destroy           ();
-  
-  Void  decompressSlice   ( TComInputBitstream** ppcSubstreams,   TComPic*& rpcPic, TDecSbac* pcSbacDecoder, TDecSbac* pcSbacDecoders );
-  Void      initCtxMem(  UInt i );
-  Void      setCtxMem( TDecSbac* sb, Int b )   { CTXMem[b] = sb; }
-  Int       getCtxMemSize( )                   { return (Int)CTXMem.size(); }
+
+  Void  decompressSlice   ( TComInputBitstream** ppcSubstreams,   TComPic* pcPic, TDecSbac* pcSbacDecoder );
 };
-
-
-class ParameterSetManagerDecoder:public ParameterSetManager
-{
-public:
-  ParameterSetManagerDecoder();
-  virtual ~ParameterSetManagerDecoder();
-  Void     storePrefetchedVPS(TComVPS *vps)  { m_vpsBuffer.storePS( vps->getVPSId(), vps); };
-  TComVPS* getPrefetchedVPS  (Int vpsId);
-  Void     storePrefetchedSPS(TComSPS *sps)  { m_spsBuffer.storePS( sps->getSPSId(), sps); };
-  TComSPS* getPrefetchedSPS  (Int spsId);
-  Void     storePrefetchedPPS(TComPPS *pps)  { m_ppsBuffer.storePS( pps->getPPSId(), pps); };
-  TComPPS* getPrefetchedPPS  (Int ppsId);
-  Void     applyPrefetchedPS();
-
-private:
-  ParameterSetMap<TComVPS> m_vpsBuffer;
-  ParameterSetMap<TComSPS> m_spsBuffer; 
-  ParameterSetMap<TComPPS> m_ppsBuffer;
-};
-
 
 //! \}
